library ieee;
use ieee.std_logic_1164.all;

entity mcm is
  port(clk, nw: in std_logic;
       A,B : in integer;
       R: out integer;
       fine: out std_logic);
end mcm;

architecture schematic of mcm is
  
 component cu2 is
   port (nw, clk, mu, mm: in std_logic;
        sela,selb,rega,regb,regm,fine: out std_logic);
 end component;
 
 component adder is
  port(A,B: in integer;
       R: out integer
     );
 end component;

 component registro is
  port (clk: in std_logic;
        mi: in integer;
        mo: out integer);
end component;

component mux is
  port (a,b: in integer;
        sel: in std_logic;
        q: out integer);
 end component;
 
 component compare is
   port(ma,mb: in integer;
        mu,mm: out std_logic
      );
end component;

signal mu, mm, sela,selb,rega,regb,regm: std_logic;
signal sa,mma,sb,mmb,ma,mb: integer;
signal clka,clkb,clkm: std_logic;

begin
  
  cu: cu2 port map (nw, clk, mu, mm,sela,selb,rega,regb,regm,fine);
  adda: adder port map(a,ma,sa);
  addb: adder port map(b,mb,sb);
  muxa: mux port map(a,sa,sela,mma);
  muxb: mux port map(b,sb,selb,mmb);
  cmp: compare port map(ma,mb,mu,mm);
  
  clka <= clk and rega;
  clkb <= clk and regb;
  clkm <= clk and regm;
  
  rga:  registro port map (clka,mma,ma);
  rgb: registro port map (clkb,mmb,mb);
  rgm: registro port map (clkm,ma,R);
end schematic; 
