library ieee;
use ieee.std_logic_1164.all;

entity memoria is
  port (addr: in integer range 0 to 255;
        cs, rw, oe: in std_logic;
        din: in std_logic_vector(15 downto 0);
        dout: out std_logic_vector(15 downto 0);
        ready: out std_logic);
end memoria;

architecture beh of memoria is
 
  type tmem is array(0 to 2**8-1) of std_logic_vector(15 downto 0);
  signal mem:tmem;
    
  begin
  process(addr,cs,rw,oe,din)
    begin
      if cs='0' then  --accesso in memoria
        if rw='1' then --lettura
           if oe='0' then -- invio dato
              dout<= mem(addr) after 5 ns;
              ready <= '1' after 5 ns;
           else dout <= (dout'range => 'Z') after 2 ns;
                ready <= '0' after 2 ns;
           end if;
       elsif rw='0' then -- scrittura
             mem(addr) <= din after 4 ns;
             ready <= '1' after 4 ns;
             dout <= (dout'range => 'Z') after 2 ns;
       else  ready <= '0' after 2 ns;
             dout <= (dout'range => 'Z') after 2 ns;
       end if;          
    else   ready <= '0' after 2 ns;
           dout <= (dout'range => 'Z') after 2 ns;
  end if;
end process;

end beh;        
      
        